#include "winc.h"
#define FUNC_PTR(f) ((fcb) f)

typedef int (*fcb) ();
int ftw_error, n_res;

void status(char *text){

	gtk_entry_set_text(GTK_ENTRY(status_e), text);

}

void found(char *line[2]){

	gtk_clist_append(GTK_CLIST(f_ctree), line);

}

int check_pattern(){

	if(strlen(pattern) < 1 || strchr(pattern, ' ') != NULL){
		status("ERROR: Invalid pattern");
		return 1;
	}
	return 0;
}

int check_root(){

	DIR *g;

	if(strlen(root_dir) < 1 || strchr(root_dir, ' ') != NULL){
		status("ERROR: Invalid directory");
		return 1;
	}
	g = opendir(root_dir);
	if(g == NULL){
		status("ERROR: Can't open root directory");
		return 1;
	}
	closedir(g);
	return 0;
}

char *flr(FILE *w){

	char *nl = "", *ol, *tmp;
	int i = 2;

	if(feof(w) != 0) return NULL;
	tmp = (char *)malloc(sizeof(char)*2);

	while(1){
		if(feof(w) != 0) return nl;
		if(ferror(w) != 0) return NULL;
		if(fread(tmp, sizeof(char), 1, w) > 0){
			i++;
			tmp[1] = '\0';
			ol = strdup(nl);
			free(nl);
			nl = (char *)malloc(sizeof(char)*i);
			strcpy(nl, ol);
			strcat(nl, tmp);
			free(ol);
			if (!strcmp(tmp,"\n")) return nl;
		}
	}
}

void file_infos(GtkWidget *w, gint row, gint col, GdkEvent *evt, gpointer g){

	FILE *pwd;
	char *time, *own, *mode, *size, *path2, *path, *file, *tmp;
	struct stat *buf;
	struct tm *ttmp;
	short int i = 0;

	time = (char *)alloca(sizeof(char)*30);
	own  = (char *)alloca(sizeof(char)*14);
	mode = (char *)alloca(sizeof(char)*30);
	size = (char *)alloca(sizeof(char)*15);
	path = (char *)alloca(sizeof(char)*300);
	path2 = (char *)alloca(sizeof(char)*300);
	file = (char *)malloc(sizeof(char)*50);
	buf  = (struct stat *)alloca(sizeof(struct stat));
	tmp  = (char *)alloca(sizeof(char)*30);

	gtk_clist_get_text(GTK_CLIST(f_ctree), row, 0, &path2);
	gtk_clist_get_text(GTK_CLIST(f_ctree), row, 1, &file);
	strcpy(path, path2);
	strcat(path, file);
	strcat(path, "\0");
	if(stat(path,buf)){
		status("Error reading file informations!");
		return;
	}
	sprintf(own, "%d", buf->st_uid);

	pwd = fopen("/etc/passwd", "r");
	if (pwd == NULL){
		status("Error opening /etc/passwd");
		gtk_label_set_text(GTK_LABEL(o_lab), own);		
	} else {
		while(1){
			path = flr(pwd);
			if (path == NULL || strlen(path) < 11){
				i = 2;
				break;
			}
			tmp = strsep(&path, ":");
			strsep(&path, ":");
			file = strsep(&path, ":");
			if(!strcmp(file, own)) break;
		}
		if(fclose(pwd) != 0){
			status("Error closing /etc/passwd");
		}
		if (i == 2){
			strcat(own, " *");
			gtk_label_set_text(GTK_LABEL(o_lab), own);
			status("* User unknowed !!!");
		} else {
			gtk_label_set_text(GTK_LABEL(o_lab), tmp);
		}
	}

	ttmp = localtime(&(buf->st_mtime));
	strftime(time, sizeof(char)*30, "%T %d %b %Y", ttmp);
	sprintf(mode, "%d", buf->st_mode);
	sprintf(size, "%d bytes", buf->st_size);

	gtk_label_set_text(GTK_LABEL(l_lab), time);
	gtk_label_set_text(GTK_LABEL(s_lab), size);
	gtk_label_set_text(GTK_LABEL(m_lab), mode);
	if(i < 2) status("Informations retreived");
}

int ftw_call_file(const char *file, struct stat *sb, int flag){

	char *msg , *l[2], *tmp;

	if (flag == FTW_D) return 0;
	tmp = strrchr(file, '/');
	if(strstr(tmp, pattern)!=NULL){
		if (flag == FTW_NS || flag == FTW_DNR) return 0;
		l[0] = (char *)malloc(sizeof(char)*(strlen(file)+2));
		msg = strrchr(file, '/');
		l[1] = strdup(++msg);
		bzero(msg, strlen(l[1])-2);
		strcpy(l[0],file);
		n_res++;
		gtk_clist_append(GTK_CLIST(f_ctree), l);
	}
	return 0;
}

int ftw_call_grep(const char *file, struct stat *sb, int flag){

	char *msg , *l[2], *tmp;
	FILE *fl;
	int found = 0;

	if (flag == FTW_D || flag == FTW_NS || flag == FTW_DNR) return 0;
	msg  = (char *)alloca(sizeof(char)*300);
	fl = fopen(file, "r");
	if (fl == NULL) return 1;
	while(1){
		tmp = flr(fl);
		if(tmp == NULL) break;
		if(strstr(tmp, pattern) != NULL) {
			found = 1;
			n_res++;
			break;
		}
	}
	if (found == 0) return 0;
	l[0] = (char *)malloc(sizeof(char)*(strlen(file)+2));
	l[1] = (char *)malloc(sizeof(char)*10);
	msg = strrchr(file, '/');
	l[1] = strdup(++msg);
	bzero(msg, strlen(l[1])-2);
	strcpy(l[0],file);
	gtk_clist_append(GTK_CLIST(f_ctree), l);
	return 0;
}


void go_search(GtkWidget *w, gpointer g){

	char *msg ;

	n_res = ftw_error = 0;
	pattern = (char *)malloc(sizeof(char)*100);
	root_dir = (char *)malloc(sizeof(char)*500);
	
	root_dir = gtk_entry_get_text(GTK_ENTRY(root_e));
	pattern = gtk_entry_get_text(GTK_ENTRY(patt_e));

	gtk_widget_set_sensitive(main_win, 0);
	if (check_root() || check_pattern()){
		gtk_widget_set_sensitive(main_win, 1);
		return;
	}
	if (GTK_TOGGLE_BUTTON(r_find)->active){
		status("Searching for file...");
		gtk_clist_clear(GTK_CLIST(f_ctree));
		ftw(root_dir, FUNC_PTR(ftw_call_file), 5);
		if(!ftw_error){
			msg = (char *)malloc(sizeof(char)*50);
			sprintf(msg, "Search finished. %d item matched", n_res);
			status(msg);
		}
        } else {
		status("Searching for substring...");
		gtk_clist_clear(GTK_CLIST(f_ctree));
		ftw(root_dir, FUNC_PTR(ftw_call_grep), 5);
		if(!ftw_error){
			msg = (char *)malloc(sizeof(char)*50);
			sprintf(msg, "Search finished. %d item matched", n_res);
			status(msg);
		}
        }
	gtk_widget_set_sensitive(main_win, 1);
}